gPass : global Password
=======================

Introduction
------------

Everyday we have a lot of passwords to manage corresponding to a lot of accounts we use. It's hard to remain all of these, moreover if we don't use it often. So, what most people do is to generate only a subset of passwords easy to remain. This implies two common errors :

 * Password are not very strong
 * We use them for multiple accounts

The best way to avoid these errors is to have a unique strong password for each account. gPass helps to reach this goal : you keep a subset of passwords (called master key) and for each login/password tuple you chose, gPass returns the real password by querying a password server.

To have a high level of security, all stored information (server side) is encrypted. Nothing is stored on client. The decryption is done on the fly when it's needed and only with user input. So, a hacker can get your password database, it will not be able to see any information (except if it bruteforce your masterkey) ! So it's important to choose to strong masterkey !

This addon is like [last pass](https://lastpass.com/) one, but I wanted it to be open source and home hostable (be careful on server down !). Moreover, with gPass, you can have multiple master keys !


Usage
-----

The first thing to do is to populate your database (from your/a password server) with website/login/password/master key values. You can use * character to access to all subdomains of a specific website. If you want to make strong password, there is a password generator. After that, configure your addon in "tools -> addons -> gPass -> preferences" to point to your password server (+ username). Be careful, login and password are case sensitive.

When you're in a login form and you want to use gPass, type your login and fill "@@masterkey" in password field. Then submit and password will automatically be replaced by the one in the database (after addon decrypt it).

You can also type "@_masterkey" to only replace your password without submiting and manually submit. This allows to support more websites.


Technical details
-----------------

The two columns in database are "login" and "password".
login is compounded by "@@domain;login" encrypted with AES 256
password is salted and encrypted with AES 256

The key that encrypt these fields is PBKDF2(hmac-sha256, masterkey, password_server_url, 1000, 256)

For now, the only addons made is for firefox. Server side is written in PHP (with SQLite3 for database component).


Server
------

To host a password server, you need a webserver. Just copy server files in a directory read/write for web server user (www-data). A sample apache2 configuration file is available in ressources. For enhanced security, it's better to put the password server under https and add authentication to admin panel. Server side is written in PHP (with SQLite3 for database component).

Configuration parameters are in conf.php

A demonstration server is available [here](http://gpass-demo.soutade.fr). It's the default server of XPI package (user demo).

**Warning** The master key derivation is partially based on account URL. So it's linked to your server information. Currently there is no simple way to export/import a full gPass database.

Client
------

Just install xpi package. You can have debug information by setting DEBUG in main.js (use it with firefox addon sdk).


Licence
-------

All the code is licenced under GPL v3. Source code is available [here](http://indefero.soutade.fr/p/gpass).
