/*
  Copyright (C) 2013-2017 Grégory Soutadé
  
  This file is part of gPass.
  
  gPass is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  gPass is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with gPass.  If not, see <http://www.gnu.org/licenses/>.
*/

function getPref(key)
{
    return browser.storage.local.get(key)
	.then(
	    function (pref) {
		if (!pref.hasOwnProperty(key))
		    return default_preferences[key];
		return pref[key];
	    }
	    ,
	    function (err) {
		console.log("Error getting preference " + err);
	    }
	);
}

function setPref(key, value)
{
    browser.storage.local.set({key:value});
}
